<template>
  <div
    class="row dropzone"
  >
    <div
      class="row justify-center items-center"
      style="font-size: 20px; width: 100%"
    >
      <!-- OVERVIEW DATA CHECK (shown if main files in checking) -->
      <div
        v-if="queueCheckingCountFiles>0"
      >
        <div style="width: 100%; font-size: 20px; text-align: center; margin-top: -40px">
          Overview<br>
          Data check
        </div>
        <q-circular-progress
          show-value
          indeterminate
          font-size="20px"
          :thickness="0.25"
          color="black"
          size="150px"
          track-color="grey-3"
          class="q-ma-md"
        >
          <q-icon
            name="policy"
            size="30px"
          />
        </q-circular-progress>
      </div>
      <!-- START UPLOAD (shown if all main files in queue, ready for upload) -->
      <div
        v-else
        style="margin-top: 40px"
      >
       <q-btn
        size="35px"
        icon="upload"
        title="Click to start uploads"
        color="grey"
        round
        @click="startUploads"
      >
        </q-btn>
        <div style="margin-top: 10px">
          Start uploads
        </div>
      </div>
      <div style="width: 100%; text-align: center; margin-top: -60px">
        <p v-if="queueCountFiles==1">
          1 File<br>
          ({{ totalMegaBytes }} MB)
        </p>
        <p v-if="queueCountFiles>1">
          {{ queueCountFiles }} Files<br>
          ({{ totalMegaBytes }} MB)
        </p>
      </div>
    </div>
    <upload-agreement
      ref="uploadAgreement"
      @accepted="acceptedAgreement"
      @acceptedRemoval="acceptedRemoval"
    />
  </div>
</template>

<script>
import { fileStatusIconMapping } from '../mixins/uploads'
import UploadAgreement from './dialogs/UploadAgreement.vue'

export default {
  name: 'UploadQueue',
  components: {
    uploadAgreement: UploadAgreement
  },
  props: {
    uploadManager: {
      type: Object,
      default: function () {
        return null
      }
    }
  },
  data () {
    return {
      fileStatusIconMapping: fileStatusIconMapping,
      queueCountFiles: 0,
      queueCheckingCountFiles: 0,
      totalMegaBytes: 0
    }
  },
  watch: {
    uploadManager: {
      handler () {
        this.queueCountFiles = this.uploadManager.getQueuedFileCount()
        this.queueCheckingCountFiles = this.uploadManager.getCheckingFileCount()
        this.totalMegaBytes = Math.round(this.uploadManager.getTotalBytesQueued() / 1000000.0)
      },
      deep: true
    }
  },
  methods: {
    acceptedAgreement () {
      this.startUploads(true)
    },
    acceptedRemoval () {
      this.uploadManager.removeFailedOrUnsupportedAnonymizationInQueue()
    },
    startUploads (acceptedUploadAgreement = false) {
      if (typeof acceptedUploadAgreement !== 'boolean') {
        acceptedUploadAgreement = false
      }
      if (this.uploadManager.hasFailedOrUnsupportedAnonymizationInQueue() && (acceptedUploadAgreement === false)) {
        this.$refs.uploadAgreement.agreement = true
        return
      }
      this.uploadManager.start()
    }
  }
}
</script>

  <style
    scoped
    lang="scss"
  >
    .dropzone {
    width: 100%;
    height: 100%;
    position: relative;
    }
</style>
